#ifndef TEST_H
#define TEST_H

#ifdef __TMS320C28XX_CLA__
#include "F2837xD_Cla_typedefs.h"
#endif
#include "F2837xD_device.h"
#include "F2837xD_Adc_defines.h"
#include "F2837xD_Gpio_defines.h"
#include "F2837xD_EPwm_defines.h"
#include "CLAmath.h"

#define CC_LD2_GPIO         31
#define CC_LD3_GPIO         34

/* Macros                                                                       */
#define DELAY_US(A)         F28x_usDelay(((((long double) A * 1000.0L) / (long double)5.0L) - 9.0L) / 5.0L)

#ifndef TABLE_BINIT
extern Uint16 RamfuncsRunStart;
extern Uint16 RamfuncsLoadStart;
extern Uint16 RamfuncsLoadSize;
extern Uint16 Cla1ProgRunStart;
extern Uint16 Cla1ProgLoadStart;
extern Uint16 Cla1ProgLoadSize;
extern Uint16 CLA1mathTablesRunStart;
extern Uint16 CLA1mathTablesLoadStart;
extern Uint16 CLA1mathTablesLoadSize;
#endif

/* Function Prototypes                                                          */
/* Interrupts                                                                   */
extern interrupt void PIE_RESERVED_ISR(void);
extern interrupt void Cla1Task1(void);
extern interrupt void Cla1Task2(void);
extern interrupt void Cla1Task8(void);
/* Cla.c                                                                        */
extern void InitCla(void);
/* Gpio.c                                                                       */
extern void InitGpio(void);
extern void GPIO_SetupPinMux(Uint16 pin, Uint16 cpu, Uint16 peripheral);
extern void GPIO_SetupPinOptions(Uint16 pin, Uint16 output, Uint16 flags);
extern Uint16 GPIO_ReadPin(Uint16 pin);
extern void GPIO_WritePin(Uint16 pin, Uint16 outVal);
/* Main.c                                                                       */
extern void main(void);
/* PieCtrl.c                                                                    */
extern void InitPieCtrl(void);
/* SysCtrl.c                                                                    */
extern void InitSysCtrl(void);
extern void DisableDog(void);
extern void ServiceDog(void);
/* usDelay.asm                                                                  */
extern void F28x_usDelay(int32 LoopCount);

#endif
