#include "test.h"

void InitCla(void) {
    EALLOW;
/* Initialize and wait                                                          */
    MemCfgRegs.MSGxINIT.bit.INIT_CLA1TOCPU = 1;
    while (MemCfgRegs.MSGxINITDONE.bit.INITDONE_CLA1TOCPU != 1);
    MemCfgRegs.MSGxINIT.bit.INIT_CPUTOCLA1 = 1;
    while (MemCfgRegs.MSGxINITDONE.bit.INITDONE_CPUTOCLA1 != 1);

/* Set CLA to master for LS1/LS2 memory sections and use for program memory     */
    MemCfgRegs.LSxMSEL.bit.MSEL_LS1 = 1;
    MemCfgRegs.LSxCLAPGM.bit.CLAPGM_LS1 = 1;
    MemCfgRegs.LSxMSEL.bit.MSEL_LS2 = 1;
    MemCfgRegs.LSxCLAPGM.bit.CLAPGM_LS2 = 1;

/* Set CLA to master for LS4/LS5 memory sections and use for data memory        */
    MemCfgRegs.LSxMSEL.bit.MSEL_LS4 = 1;
    MemCfgRegs.LSxCLAPGM.bit.CLAPGM_LS4 = 0;
    MemCfgRegs.LSxMSEL.bit.MSEL_LS5 = 1;
    MemCfgRegs.LSxCLAPGM.bit.CLAPGM_LS5 = 0;

    Cla1Regs.MVECT1 = (Uint16)(((Uint32)&Cla1Task1) & 0xFFFF);
    Cla1Regs.MVECT2 = (Uint16)(((Uint32)&Cla1Task2) & 0xFFFF);
    Cla1Regs.MVECT8 = (Uint16)(((Uint32)&Cla1Task8) & 0xFFFF);

/* Enable IACK instructions to force trigger tasks                              */
    __asm(" RPT #3 || NOP");
    Cla1Regs.MCTL.bit.IACKE = 1;

/* Enable tasks                                                                 */
    Cla1Regs.MIER.all   = 0x0083;

    EDIS;
}
